/*
Copyright (C) 2024 - 2025 3NSoft Inc.

This program is free software: you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program. If not, see <http://www.gnu.org/licenses/>.
*/

import { appChatsSrv, appDeliverySrv, fileLinkStoreSrv } from '@main/services/services-provider';
import { ChatsStore } from '@main/store/chats.store';
import type { ChatMessageView, MessageType, SystemMessageHandlerParams } from '~/index';
import { isEmpty } from 'lodash';
import { ChatStore } from '@main/store/chat.store';
import { Ref } from 'vue';

export async function handleDeleteChatMessage(
  fetchChatList: ChatsStore['fetchChatList'],
  currentChatId: Ref<ChatStore['currentChatId']>,
  fetchChat: ChatStore['fetchChat'],
  {
    chatId,
    value,
  }: SystemMessageHandlerParams
): Promise<void> {
  if (!chatId || (chatId && !value)) {
    return;
  }

  const { chatMessageId } = value;
  const message = await appChatsSrv.getMessage({ chatMsgId: chatMessageId });

  if (!message) {
    return;
  }

  await deleteChatMessageFromInbox(chatMessageId, message);
  if (chatId === currentChatId.value) {
    await fetchChat(chatId);
  } else {
    await fetchChatList();
  }
}

async function deleteChatMessageFromInbox(
  chatMsgId: string, message: ChatMessageView<MessageType>
): Promise<void> {
  const { messageType, attachments, msgId } = message;
  await appChatsSrv.deleteMessage({ chatMsgId });
  if (messageType === 'incoming') {
    await appDeliverySrv.removeMessageFromInbox([msgId]);
  } else {
    await appDeliverySrv.removeMessageFromDeliveryList([msgId]);
    if (!isEmpty(attachments)) {
      for (const attachment of attachments!) {
        const { id } = attachment;
        id && await fileLinkStoreSrv.deleteLink(id);
      }
    }
  }
}
